#include "pixt.h"

drawLine(x1,y1,x2,y2)
	int x1,y1,x2,y2;
{
/* this is modified from Bresenham's Algorithm from Foley & Van Dam.
 * since we only have one cartesian quadrant to work with in X, i
 * coerce all lines to have x1 < x2 and "increment" y by +1 or -1,
 * depending upon whether y1 > y2.
 */
	int dx, dy, d, inc1, inc2, incy, tmp;
	int x, y;
	if (x1==x2) { 
		if (y1==y2) 		/* this ain't no line! */
			return;
		else if (y1>y2) { 
			tmp = y1;
			y1 = y2;
			y2 = tmp;
		}
		for (y=y1;y<=y2;y++)	/* the vertical line */
			setCell(x1,y);
	}
	else if (y1==y2) {
		if (x1>x2) {
			tmp = x1;
			x1 = x2;
			x2 = tmp;
		}
		for (x=x1;x<=x2;x++)	/* the horizontal line */
			setCell(x,y1);
	}
	else {
		if (x1 > x2) {
			tmp = x1;
			x1 = x2;
			x2 = tmp;
			tmp = y1;
			y1 = y2;
			y2 = tmp;
		}
		dx = abs(x2 - x1);
		dy = abs(y2 -y1);
		d  = 2*dy-dx;
		inc1 = 2*dy;
		inc2 = 2*(dy - dx);
		incy = (y1 > y2)?-1:1;
		setCell(x1,y1);
		while (x1 < x2) {
			x1++;
			if (d < 0) 
				d += inc1;
			else {
				y1 += incy;
				d += inc2;
			}
			setCell(x1,y1);
		}
	}
}

