#include "pixt.h"

extern XImage *global_xim;

static char *getline();

redrawPixmap();
char *getFileName();


char *syms = "!#$%&()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[]^_`abcdefghijklmnopqrstuvwxyz{|}~";


writePixmap(row, col, width, height, fname)
	int row, col, width, height;
	char *fname;
{
	Pixmap tmpmap;
	int r;
	int row, col, i;
	char str[80];
	int screen = DefaultScreen(display);

	/* here's an interesting problem: if i attempt to get an
	** image out of the pixwin, it may be covered by the file
	** selection box that hasn't been completely unmapped, so
	** the image i get is wrong. i've tried XSync, XmUpdateDisplay,
	** etc., and nothing works. so, the solution is to grab an image
	** before i pop up the fsb just in case it's needed...i store this
	** in a global XImage structure...
	*/
	tmpmap = XCreatePixmap(display,pixwin,width,height,
			DefaultDepth(display,screen));
	XPutImage(display,tmpmap,paintGC,global_xim,0,0,0,0,width,height);
	r = XWritePixmapFile(display,cmap,fname,tmpmap,width,height);
	XFreePixmap(display,tmpmap);
	if (r != PixmapSuccess) return(-1);
}

readPixmap(fname)
	char *fname;
{
	int fd, width, height, num_read;
	int ret;
	int depth; 
	Pixmap tmpmap;
	int screen = DefaultScreen(display);
	FILE *fstream;
  	char linebuf[256] ;
  	char namebuf[256];
  	char type[256];
  	char name[256];
	int p;

	/* these next few lines are copied out of the XReadPixmapFile
	** function. what I want to do is allow the reading of pixmaps
	** that are not the exact same size of the current grid. if the
	** pixmap is too big, it will be cropped. if is is too small, then
	** justify it at 0,0. however, you have to pass the width and
	** height to XReadPixmapFile-- so, I open the pixmap, read width
	** and height, close the file and pass the dimensions to the xpm
	** function. whew!
	*/
	if ((fstream = fopen(fname, "r")) == NULL) {
		return(-1);
	}

	getline(linebuf,fstream);	
	if ((sscanf(linebuf, "#define %[^_]%s %d", namebuf,type,&p) != 3) 
      		|| ((strcmp("_format",type)) && (strcmp("_paxformat",type)))
      		|| (p != XPM_FORMAT)) {
    		return(-1);
	}
	else 
		strcpy(name,namebuf);

	getline(linebuf,fstream);
	if ((sscanf(linebuf, "#define %[^_]%s %d",namebuf,type,&width) != 3)
      		|| (strcmp(name,namebuf)) 
      		|| (strcmp("_width",type))) {
		return(-1);
	}
  	getline(linebuf,fstream);
  	if ((sscanf(linebuf, "#define %[^_]%s %d",namebuf,type,&height) != 3)
      		|| (strcmp(name,namebuf)) 
      		|| (strcmp("_height",type))) {
		return(-1);
	}
	fclose(fstream);
	/* end of code from xpm_read.c */

	depth = DefaultDepth(display,screen);
	ret = XReadPixmapFile(display,pixwin,cmap,fname,
			&width, &height,
			depth, &tmpmap);

	if (ret == PixmapSuccess)
		redrawFromPixmap(tmpmap,width,height);
	else
		return(-1);	
}


writeUIL()
{
	/*
	** write out a bit of uil code describing the color_table
	** and icon for this particular pixel drawing...
	*/
	FILE *f;
	char colorstr[256], 
	     iconstr[256],
	     *s, *tok, *last, *obname;
	int i, r, c, p;
	int NumUsed;
	Boolean used[XtNumber(colornames)];

	/* the file selection box and its callbacks stuffed the name
	** of the file into the global globalFileName...
	*/
	if ((f = fopen(globalFileName,"w")) == NULL) {
		return(-1);
	}

	/*
	** set up our array of booleans that will keep track of which
	** colors have been used...
	*/
	for (i=0;i<XtNumber(colornames);i++)
		used[i] = False;

	/* we want to use the file name as the name of the icon-- so,
	** we need to strip off all the path shit and the .icon suffix
	*/
	s = globalFileName;
	if (( tok = strrchr(s,'/')) == NULL)
		tok = s;
	else
		tok += 1;
	if (( s = strrchr(tok,'.')) != NULL)
		strncpy(colorstr,tok,strlen(tok)-strlen(s));
	else
		strcpy(colorstr,tok);
	/*
	** now we have the name of the icon-- we can start writing out the
	** uil code. first, find out which colors were used so that we 
	** include the minimum colors in the color_table...
	*/
	strcpy(iconstr,colorstr);
	strcat(colorstr,"_colors");
	fprintf(f,"value %s : color_table (\n",colorstr);
	NumUsed = 0;
	for (r=0,i=0;r<NumRows;r++)
		for (c=0;c<NumCols;c++,i++) 
			if (!used[PixColors[i]]) {
				used[PixColors[i]] = True;
				NumUsed++;
			}
	for (i=0,p=0;i<XtNumber(colornames);i++)
		if (used[i]) {
			p++;
			fprintf(f,"\tcolor('%s') = '%c'",
				colornames[i], syms[i]);
			if (p<NumUsed) fprintf(f,",");
			fprintf(f,"\n");
		}
	fprintf(f,");\n\n");

	strcat(iconstr,"_icon");
	fprintf(f,"value %s : icon (\n",iconstr);
	fprintf(f,"\tcolor_table = %s,\n",colorstr);

	for (r=0,i=0;r<NumRows;r++) {
		fprintf(f,"\t'");
		for (c=0;c<NumCols;c++,i++)
			fprintf(f,"%c",syms[PixColors[i]]);
		fprintf(f,"'");
		if (r<NumRows-1) fprintf(f,",");
		fprintf(f,"\n");
	}
	fprintf(f,");\n");
	fclose(f);
}
			
popInputDialog(prompt,suffix)
	char *prompt;
	char *suffix;
{
	Arg args[5];
	XtSetArg(args[0],XmNlabelString,
		XmStringCreateLtoR(prompt,XmSTRING_DEFAULT_CHARSET));
	XtSetValues(inDialogLabel,args,1);
	XtSetArg(args[0],XmNtextString,
		XmStringCreateLtoR(suffix,XmSTRING_DEFAULT_CHARSET));
	XtSetArg(args[1],XmNdialogStyle,XmDIALOG_APPLICATION_MODAL);
	XtSetValues(inDialog,args,2);
	XtSetArg(args[0],XmNcursorPosition,0);
	XtSetValues(inDialogText,args,1);
	XtManageChild(inDialog);
}


void inDialogCancelCB(w,client,call)
	Widget w;
	caddr_t client;
	XmSelectionBoxCallbackStruct *call;
{
	/* this function is being called because the user pressed the cancel
	 * button in the input dialog. just set the globalfilename to null
	 * and beat feet
	 */
}


void inDialogOKCB(w,client,call)
	Widget w;
	caddr_t client;
	XmSelectionBoxCallbackStruct *call;
{
	/* this function is called when the user presses the OK button 
	 * in the input dialog. presumably there is a valid file name
	 * in the call structure.... the is only a temporary workaround
	 * until the file selection widget is fixed.
	 */
	char **fname;
	XmStringGetLtoR(call->value,XmSTRING_DEFAULT_CHARSET,fname);
	strcpy(globalFileName,*fname);
	if (strlen(*fname) == 0)
		return;
	switch (FileState) {
	case F_READ:
		if (readPixmap(*fname) == -1)
			popMessage("Read of Pixmap failed...");
		break;
	case F_WRITE_UIL:
		if (writeUIL()== -1)
			popMessage("Write of UIL Icon file failed.");
		break;
	case F_WRITE:
		if (writePixmap(0,0,NumCols,NumRows,*fname)== -1)
				popMessage("Write of Pixmap failed...");
		break;
	}
}


/*
 * read the next line and jump blank lines 
 */
static char *
getline(s,pF)
     char * s ;
     FILE * pF ;
{
    s = fgets(s,256,pF);

    while (s) {
	int len = strlen(s);
	if (len && s[len-1] == '\015')
	    s[--len] = '\0';
	if (len==0) s = fgets(s,256,pF);
	else break;
    }
    return(s);
}
	    
